pico-8 cartridge // http://www.pico-8.com
version 42
__lua__
--friday night funkin' in pico-8
--made by carson k and chris w

function _init()
	poke(0x5f2d,1)
	cartdata("ckcw_fnfp8")
	step = 0
	inc = 509/64--509/32
	logo = 1
	menustate = -1
	fade = 0
	fading = -1
	splash_init()
	music(0)
	synctime = 509
	dset(60,0)
	if(flr(rnd(100)) == 0) logo = 2
end

function _update60()
	--step = stat(26) + (stat(24)*  509)
	if(menustate == 0 or menustate == 1) menu_update()
	if(menustate == -1) splash_update()
	step+=1
	poke(0x5f30,1)
	--if(stat(26) > synctime) synctime = stat(26)
end

function _draw()
	cls()
	palt(0,false)
	palt(9,true)
	rectfill(0,0,128,128,0)
	color(6)
	if(menustate == -1) splash_draw()
	if(menustate == 0 or menustate == 1) menu_draw()
	if fading > -1 then
		if(fading == 0) fade0(ceil(fade))
		if(fading == 1) fade1(ceil(fade))
		if(fading == 2) fade0(15-ceil(fade))
		if(fading == 3) fade1(15-ceil(fade))
		if(fade > 0) fade -= 0.5
		if fade == 0.5 and menustate == 0 and fading == 2 then
			--fade = 15
			--fading = 0
			--menustate = 1
			dset(59,max(0,stat(24)-2))
			load("#fnf_select")
		end
		if fade == 0 and menustate == 1 and fading == 2 then
			--load cart
			if not loading then
				music(-1)
				load(menubtns[state+1][4])
				loading = true
			end
		end
	end
end
-->8
--main menu
function menu_init()
	menustate = 0
	state = 0
	nextstate = -1
	starting = -1
	loading = false
end

function menu_update()
	if nextstate > 0 then
		nextstate -= 1
		if nextstate == 0 then
			fading = 2
			fade = 15
			nextstate = 0
		end
	end
	
	if starting > 0 then
		starting -= 1
		if starting == 0 then
			fading = 2
			fade = 15
		end
	end
	
	if menustate == 0 and nextstate == -1 then
		--press enter to start
		if btnp() == 64 then
			nextstate = 30
			sfx(5,2)
			poke(0x5f30,1)
		end
	end
end

function menu_draw()
	if menustate == 0 then
		rectfill(0,0,128,128,0)
		--girlfriend outline
		for i=0,15 do
			pal(i,12)
		end
		draw_girlfriend(49-1,60)
		for i=0,15 do
			pal(i,14)
		end
		draw_girlfriend(49+1,60+1)
		for i=0,15 do
			pal(i,i)
		end
		--girlfriend
		draw_girlfriend(49,60)
		
		--logo
		draw_logo(logo,63,6)
		
		local _incc = 4
		if(nextstate > 0) _incc = 1
		if flr(step/(inc*_incc))%2 == 1 then
			local _tx = "pRESS eNTER TO bEGIN"
			for i=-1,1 do
				for j=-1,1 do
					print(_tx,i+64-#_tx*2,j+114,0)
				end
			end
			print(_tx,64-#_tx*2,114,7)
		end
	end
end
-->8
--splash screen

function splash_init()
	splashstate = 0
	splashtext = get_splash_text()
	ispresident = flr(rnd(100)) == 0
end

function splash_update()
	if btnp() == 64 then
		splashstate = 0
		menu_init()
		fading = 1
		fade = 15
		poke(0x5f30,1)
	end
	if splashstate == 0 and step >= inc*6 then
		splashstate = 1
	elseif splashstate == 1 and step >= inc*16 then
		splashstate = 2
	elseif splashstate == 2 and step >= inc*22 then
		splashstate = 3
	elseif splashstate == 3 and step >= inc*32 then
		splashstate = 4
	elseif splashstate == 4 and step >= inc*38 then
		splashstate = 5
	elseif splashstate == 5 and step >= inc*48 then
		splashstate = 6
	elseif splashstate == 6 and step >= inc*52 then
		splashstate = 7
	elseif splashstate == 7 and step >= inc*56 then
		splashstate = 8
	elseif splashstate == 8 and step >= inc*60 then
		splashstate = 9
	elseif splashstate == 9 and step >= inc*64 then
		splashstate = 0
		menu_init()
		fading = 1
		fade = 15
	end
end

function splash_draw()
	--print(splashtext[1],63,63)
	local _tx = ""
	if splashstate == 0 or splashstate == 1 then
		_tx = "cARSON kOMPON"
		print(_tx,64-#_tx*2,54)
		_tx = "& cHRIS wEST"
		print(_tx,64-#_tx*2,60)
		if splashstate == 1 then
			_tx = "present"
			if(ispresident) _tx = "& tHE pRESIDENT"
			print(_tx,64-#_tx*2,66)
		end
	elseif splashstate == 2 or splashstate == 3 then
		_tx = "originally created by:"
		print(_tx,64-#_tx*2,48)
		if splashstate == 3 then
			_tx = "nINJAmUFFIN"
			print(_tx,64-#_tx*2,54)
			_tx = "pHANTOMaRCADE"
			print(_tx,64-#_tx*2,60)
			_tx = "kAWAIsPRITE"
			print(_tx,64-#_tx*2,66)
			_tx = "eVILsKER"
			print(_tx,64-#_tx*2,72)
		end
	elseif splashstate == 4 or splashstate == 5 then
		_tx = splashtext[1]
		print(_tx,64-#_tx*2,56)
		if splashstate == 5 then
			_tx = splashtext[2]
			print(_tx,64-#_tx*2,62)
		end
	elseif splashstate == 6 or splashstate == 7 or splashstate == 8 or splashstate == 9 then
		_tx = "fRIDAY"
		print(_tx,64-#_tx*2,52)
		if splashstate >= 7 then
			_tx = "nIGHT"
			print(_tx,64-#_tx*2,58)
			if splashstate >= 8 then
				_tx = " fUNKIN'"
				print(_tx,64-#_tx*2,64)
				if splashstate >= 9 then
					_tx = "pico-8"
					print(_tx,64-#_tx*2,70)
				end
			end
		end
	end
end

--splash texts
function get_splash_text()
	local _splashs = "SHOUTOUTS TO TOM FULP:LMAO|DA BABY:BIGGEST INSPIRATION|THIS GAME IS DEDICATED TO RINGO:MY FAVORITE BEATLE|THAT'S A HEALTHY LOOKING PENIS:THAT'S AN AMERICAN PENIS|pico-8 EXCLUSIVE:SPLASH TEST|REFINED TASTE IN MUSIC:IF I SAY SO MYSELF|SWAGSHIT:MONEYMONEY|RHYTHM GAMING:DEMADE|RITZ DX:REST IN PEACE LOL|nEWGROUNDS IS DOWN!:pLEASE sTAND bY ♥ |BACK THE FULL ASS GAME:NOW|NEWGROUNDS:FOREVER|RATE FIVE:PLS NO BLAM|GAME OF THE YEAR:FOREVER|STREAM CHUCKIE FINSTER:ON SPOTIFY|NEVER FORGET TO:PRAY TO GOD|LIKE PARAPPA:BUT COOLER|HATSUNE MIKU:BIGGEST INSPIRATION|WOMEN ARE REAL:THIS IS OFFICIAL|DANCIN:FOREVER|DOPE ASS GAME:PLAYSTATION MAGAZINE|GO MANGO:GO MANGO|DONT PLAY RUST:WE ONLY FUNKIN'|GOODBYE:MY PENIS|HOW I ACCIDENTALLY:MADE FNF IN pico-8|YOOOOOOOOO:yooooooooo|YOU ALREADY KNOW:WE REALLY OUT HERE| :WE HAVE FUN HERE|CLOUD BASHERS:BEST RHYTHM GAME|SUPER PICKLE MILK:ITS THE SAME THING|TURNIP BOY:COMMITS FUNK EVASION|THE LAST FUNK:PIPIN' HOT|PERFECT LAWN:ONE BROWN SPOT|wEEK 7:YES ITS HERE|YOURE SO SUSSY:I KNOW YOU TOOK MY FORTNITE CARD|$19 FORTNITE CARD:WHO WANTS IT?|DARNELL FOR PRESIDENT!:HE STILL HAS 5 YEARS TO LIVE|THAT'LL BE 15 DOLLARS:YOU ARE THE PRESIDENT| :NAME A WOMAN|FUCKIN' STEAK BABY:YEAH|NINJAMUFFIN'S BEEN REAL QUIET:SINCE WEEK 7 DROPPED|DOWNSCROLL:NEVER HEARD OF IT|WE ACTUALLY FUCKING:UPDATED IT|YES...:WE ADDED WEEK 2|CHECK OUT THE MODS:ON LEXALOFFLE|THE MODDING SCENE:IS INSANE|I ADDED MORE:SPLASH TEXT|NOW WITH:WEEK 2|HORSE:OOH AH OOH AH|WEEK 8:NEVER HAPPENING LMAO|JINGLE:BALLS| :PROBLEM NOOB?|WE UPDATED IT:TWICE|WE NEED:MORE SPLASH TEXT|WE MADE WEEK 5:IN A DAY|GO PICO GO GO:GO PICO, YEAH|YOU CAN USE dfjk NOW:CRY ABOUT IT|dfjk IS REAL:THIS IS OFFICIAL|KEYBINDS?:WHAT?|FUNKY-US MCPUNK:HE'S FUNKING OUT HIS PUNK|WE HAVE ALL THE WEEKS NOW:YES, ACTUALLY|DID YOU KNOW JOE SWANSON SAYS:FORTNITE IN FAMILY GUY LOL"
	local _splash = split(_splashs,"|")
	return split(_splash[flr(rnd(#_splash))+1],":")
end
-->8
--fades

--fade to black
local fadetable0={
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{1,1,1,1,1,1,1,0,0,0,0,0,0,0,0},
{2,2,2,2,2,2,1,1,1,0,0,0,0,0,0},
{3,3,3,3,3,3,1,1,1,0,0,0,0,0,0},
{4,4,4,2,2,2,2,2,1,1,0,0,0,0,0},
{5,5,5,5,5,1,1,1,1,1,0,0,0,0,0},
{6,6,13,13,13,13,5,5,5,5,1,1,1,0,0},
{7,6,6,6,6,13,13,13,5,5,5,1,1,0,0},
{8,8,8,8,2,2,2,2,2,2,0,0,0,0,0},
{9,9,9,4,4,4,4,4,4,5,5,0,0,0,0},
{10,10,9,9,9,4,4,4,5,5,5,5,0,0,0},
{11,11,11,3,3,3,3,3,3,3,0,0,0,0,0},
{12,12,12,12,12,3,3,1,1,1,1,1,1,0,0},
{13,13,13,5,5,5,5,1,1,1,1,1,0,0,0},
{14,14,14,13,4,4,2,2,2,2,2,1,1,0,0},
{15,15,6,13,13,13,5,5,5,5,5,1,1,0,0}
}

function fade0(i)
for c=0,15 do
  if flr(i+1)>=16 then
pal(c,0,1)
else
pal(c,fadetable0[c+1][flr(i+1)],1)
end
 end
end

-- fade to white
local fadetable1={
{0,0,1,1,5,5,5,13,13,13,6,6,6,6,7},
{1,1,5,5,13,13,13,13,13,6,6,6,6,6,7},
{2,2,2,13,13,13,13,13,6,6,6,6,6,7,7},
{3,3,3,3,13,13,13,13,6,6,6,6,6,7,7},
{4,4,4,4,4,14,14,14,15,15,15,15,15,7,7},
{5,5,13,13,13,13,13,6,6,6,6,6,6,7,7},
{6,6,6,6,6,6,6,6,7,7,7,7,7,7,7},
{7,7,7,7,7,7,7,7,7,7,7,7,7,7,7},
{8,8,8,8,14,14,14,14,14,14,15,15,15,7,7},
{9,9,9,10,10,10,15,15,15,15,15,15,15,7,7},
{10,10,10,10,10,15,15,15,15,15,15,15,7,7,7},
{11,11,11,11,11,11,6,6,6,6,6,6,6,7,7},
{12,12,12,12,12,12,6,6,6,6,6,6,7,7,7},
{13,13,13,13,6,6,6,6,6,6,6,6,7,7,7},
{14,14,14,14,14,15,15,15,15,15,15,7,7,7,7},
{15,15,15,15,15,15,15,7,7,7,7,7,7,7,7}
}

function fade1(i)
 for c=0,15 do
  if flr(i+1)>=16 then
   pal(c,7,1)
  else
      pal(c,fadetable1[c+1][flr(i+1)],1)
     end
 end
end
-->8
--draw chars
function draw_girlfriend(_x,_y)
	if flr(step/(inc*4))%2==0 then
		sspr(2,95,13,15,_x+30,_y+31)
		sspr(2,95,13,15,_x-12,_y+31,12,15,true)
		sspr(0,0,30,46,_x,_y)
	else
		sspr(15,95,12,15,_x+30,_y+31)
		sspr(15,95,12,15,_x-12+1,_y+31,11,15,true)
		sspr(0,46,30,47,_x,_y-1)
	end
end
-->8
--draw logo

function draw_logo(_id,_x,_y)
	if _id == 0 then
		sspr(58,0,70,42,_x-35,_y)
	elseif _id == 1 then
		sspr(57,43,71,42,_x-35,_y)
	elseif _id == 2 then
		sspr(58,86,70,43,_x-35,_y)
	end
end
__gfx__
99999999999922229999999999999999999999999999999999999999999999999999999911111199999999999999119991191911999991111111999999999999
99999999999992422229999999999999999999999999999999999999999999999999991100000011999999991111001991191111199111000000111999999999
99999999922222244444299999999999999999999999999999999999999999999991110088808001111199910001080199111111111100008882000199999999
999999924444444444f4429999999999999999999999999999999999999999999910002888002000000111110880080111000000000088802888882011999999
999999244444444f44f4449999999999999999999999999999999999999999999102888880808080000000000880028010288200022088800008888201999999
9999994ff44ff44fff44442999999999999999999999999999999999999999991028888888002000882028000880008000888000288202808808888801999999
9992994444f4f4f44444442999999999999999999999999999999999999999111028888888208002888088820280880800888000888820808808888801999999
99929224444444444444442999999999999999999999999999999999999999111088800082000008808080088088880800882082088880808808800011999999
99944244444444444444422999999999999999999999999999999999999999911088888000000008208080008088202820880288080880888808801119999999
99924242224442ee244ee42999999999999999999999999999999999999999111088888082088028008082088088088880880082080880888808820199999999
999922222e24e220e22fe24229999999999999999999999999999999999991110088800888088088088088888088028888880200080000888808880119999999
999992222e00ee402e2f222299999999999999999999999999999999999999110288802802088088882088888088008888880808880880808808880011111999
999992242ee0eff4f422224999999999999999999999999999999999999991110888808800880088820288082028208808880802880080202808888000000199
999992442ef4fffff442444292999999999999999999999999999999999991002888808800820000000080000002202800820800888220002202882006760199
99999942efff2082f224444442999999999999999999999999999999999910288888808200006777760000000000000000000820220000000000280077760199
99999940effff88ff424444429999999999999999999999999999999999910888888800067777777770006776006760006760000000770006760000067701199
99929444002222222ef2444429999999999999999999999999999999999910888820006777777777770677777007776000777000006776067770000006601999
99922444442888884ffe444442999999999999999999999999999999999910882006777777777777770777777007777700776000670770077760067600001999
999244444e02222224ff444442999999999999999999999999999999999910220067777777777777770777777007777600770006770660677700077776001999
999924444e00000222ff444422999999999999999999999999999999999910006777777777777777770677777606777006760007777000777700677777701999
99999444e2efff4400ef244299999999999999999999999999999999999910677777777777777777770077777700777007700067776060777700777777601999
9999924ff2fffffffe0ffe2299999999999999999999999999999999999106777777777777777777760067777700777067700677760670777760777776001999
999111ef42ef222eff0ef22f21199999999999999999999999999999999107777777777760006777600000077700777077706776000770777770777760001999
911555552ef2fff2ee46666555511999999999999999999999999999999107777777760000000000067776067760677077777770000770677777777700011999
91055622fff2fee22111110665051999999999999999999999999999999106600777700066000006777777607770077077777777600776077777777700119999
150122ffff22ffe21111166606015199999999999999999999999999999100000777777777600007777777707776077077777777760777077777777701119999
156288822222eff00016661110655199999999999999999999999999999100000777777777700007777777707777777077777777770677067077777701199999
0560228820202ef25561111110655099999999999999999999999999999110000777777777706007777777707067777067776007776077606067777760119119
05611122111022fe2201111111615099999999999999999999999999999911110777777777607007777777607007777007770007777077700007777770111119
55611111111022ff8201111111615599999999999999999999999999999991110777777600067007777770067606777606770007777067760006777776011199
556011111111028f8211111110615599999999999999999999999999999999110777770006777007777770777700777700060007777607770000777777601119
55601111110000288200111110615599999999999999999999999999999911100777770007777777777770777700677760000007777707776000777777760111
55560111000000022200001106155599999999999999999999999999991110006777777607777777777770777700077776000007777606777600677777776011
55556660000000000000000661555599999999999999999999999999991106777777777707777777777760677760067777777007776000777700067777777601
55555116666666666666666155555599999999999999999999999999991067777777777607777777777700006770007777776007760000677600007067776601
55555566000000011000006655555599999999999999999999999999991077776000770006777777777600000060006777600006600000070000006000000001
55556601111111111111166066555599999999999999999999999999991060000000670000777777770001000660000660000000000100066000000000000011
55560011111111111111661100655599999999999999999999999999991000000000060000700070070001110660000000000000001110066001100000000019
55560111111100000016111110655599999999999999999999999999991100000000000000660000060001110000000000000100011911100011111100000119
05561111111055555501111111655099999999999999999999999999991100001111111110660000000111191111100000011111119111111119999911111999
01161111111055555501111111611099999999999999999999999999999111111199999911000001111199999999110001111111199119911999999999999999
01160111111055555501111110611099999999999999999999999999999111199999999999111119999999999999991119911999999999999999999999999999
01160111111100000011111110611099999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999
01156011000000000000001106511099999999999999999999999999999999999911111111199999999999999999119991191911999991111111999999999999
90115660000000000000000665110999999999999999999999999999999999991110000000111199999999991111001991191111199111000000111999999999
90111556660000000000666551110999999999999999999999999999999999911002888820001111199911110001020199111111111100008882000199999999
99999999999999999229999999999999999999999999999999999999999999110288888882080111111100000000280111000000000088802888882011999999
99999999999999999922299999999999999999999999999999999999999991102888222880020010000002888200882010288200022088800008888201999999
99999999999992222224429999999999999999999999999999999999999991028882000208080800888028888820288000888000288202808808888801999999
99999999999244444222222999999999999999999999999999999999999991088880000080020008882088200882088200888000888820808808888801999999
99999999299444444444444429999999999999999999999999999999999911088880000288080028820288000088088800882082088880808808800011999999
999999929924f444444444f442999999999999999999999999999999999111088880028888000088800888000088088820880288080880888808801119999999
99999992922fffffff4f4fff44999999999999999999999999999999999111082088888882088088800288000088088880880082080880888808820199999999
99999924244444f4f4ff444444299999999999999999999999999999999111020088882220288088800088800882028888880200080000888808880119999999
99999924442444444444444444499999999999999999999999999999999991000088880000888028882202888820008888880808880880808808880011111999
99999992224444424444444444499999999999999999999999999999999991100088882008882002888820288200008808880802880080202808888000000199
999999992422e2224e24444442499999999999999999999999999999999999100288888002820000000000000000002800820800888220002202882006760199
999999992222002ee20224ee44299999999999999999999999999999999999100888882000000000000000000000000000000820220000000000280077760199
999999922242e00eee02e22e22299999999999999999999999999999999999110888200000000000000006776006760006760000000770006760000067701199
99999992242ff44eff4f442222299999999999999999999999999999999991110220006777777760000677777007776000777000006776067770000006601999
99999992442fffffffff222242999999999999999999999999999999999911100000677777777776000777777007777700776000670770077760067600001999
99999299240fff2082ff242449922999999999999999999999999999999991100067777777777777000777777007777600770006770660677700077776001999
9999922244400ff88ff2242442242999999999999999999999999999999910006777777776006777600677777606777006760007777000777700677777701999
99999924444e2880042e424444429999999999999999999999999999999910067777776000000777700077777700777007700067776060777700777777601999
999999224444288224ef244444299999999999999999999999999999999100077777760000000777700067777700777067700677760670777760777776001999
999999224440222224ff244444429999999999999999999999999999999100677777700000000777600000077700777077706776000770777770777760001999
9999999244200000244f244444429999999999999999999999999999999100777777700000006777067776067760677077777770000770677777777700011999
99999999422effff000fe24444299999999999999999999999999999999100677777700000067776077777607770077077777777600776077777777700119999
99999992ef2fffffffe2fffe22999999999999999999999999999999999100660677700000677760677777707776077077777777760777077777777701119999
9991112ff2eff22efff2f22fe1199999999999999999999999999999999100000077700677777600777777707777777077777777770677067077777701199999
911555555eff2ff4ef46666655511999999999999999999999999999999110000077777777776006777777707067777067776007776077606067777760119119
910555624ff2feef2411110066051999999999999999999999999999999911000077777777600007777777607007777007770007777077700007777770111119
1501522eff41ffef1111166610615199999999999999999999999999999991000677777760006007777770067606777606770007777067760006777776011199
155628822221eff21111661111065199999999999999999999999999999991000777776000067007777770777700777700060007777607770000777777601119
0556022220210ef42016111111065099999999999999999999999999999991000777770006777777777770777700677760000007777707776000777777760111
05161111111052ff2261111111065099999999999999999999999999999111000777770007777777777770777700077776000007777606777600677777776011
55161111111052ff8221111111065599999999999999999999999999991100006777776007777777777760677760067777777007776000777700067777777601
551611111111028f8821111111065599999999999999999999999999991000677777777707777777777700006770007777776007760000677600007067776601
55516111000000288820001110615599999999999999999999999999911006777777777607777777777600000060006777600006600000070000006000000001
55551600000000022200000006155599999999999999999999999999911006777777770006777777770001000660000660000000000100066000000000000011
55555166000000000000006661555599999999999999999999999999991000677760770000700070070001110660000000000000001110066001100000000019
55555555111111111111111555555599999999999999999999999999911100007000670000660000060001110000000000000100011911100011111100000119
55555566666666666666666655555599999999999999999999999999991100007010060110660000000111191111100000011111119111111119999911111999
55556600000000000000000066555599999999999999999999999999999111110011100111000001111199999999110001111111199119911999999999999999
55560111111111111111666110655599999999999999999999999999999111191199911999111119999999999999991119911999999999999999999999999999
55601111111111111116611111065599999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999
05011111111110000661111111105099999999999999999999999999999999999999999911111199999999999999119991191911999991111111999999999999
01011111111105555011111111101099999999999999999999999999999999999999991100000011999999991111001991191111199111000000111999999999
01011111111105555011111111101099999999999999999999999999999999999991110088808001111199910001080199111111111100008882000199999999
01601111110000000000111111061099999999999999999999999999999999999910002888002000000111110880080111000000000088802888882011999999
01560110000000000000000110651099999999999999999999999999999999999102888880808080000000000880028010288200022088800008888201999999
90155660000000000000000066510999999999999999999999999999999999991028888888002000882028000880008000888000288202808808888801999999
90111556666000000006666655110999999999999999999999999999999999111028888888208002888088820280880800888000888820808808888801999999
99999999999999999999999999999999999999999999999999999999999999111088800082000008808080088088880800882082088880808808800011999999
99999999999999999999999999999999999999999999999999999999999999911088888000000008208080008088202820880288080880888808801119999999
99000111199999900011199999999999999999999999999999999999999999111088888082088028008082088088088880880082080880888808820199999999
99006555511119900655511199999999999999999999999999999999999991110088800888088088088088888088028888880200080000888808880119999999
99116550000551911655000511999999999999999999999999999999999999110288802802088088882088888088008888880808880880808808880011999999
99116505111065111650511065199999999999999999999999999999999991110888808800880088820288082028208808880802880080202808888011999999
99116505511105111650551105199999999999999999999999999999999991002888808800200000000080000002202800820800888220002202882011999999
99116501661105111650161105199999999999999999999999999999999910288888808200067600000000000000000000000820000000000000280001119999
99116550011165111550001165199999999999999999999999999999999910888888800067777700000000066000677600000000676067600066000000011199
99116555000655111555500655199999999999999999999999999999999910888820067777777700000067606760600060000000777077777600677600001199
99116500005555111550005555199999999999999999999999999999999910882006777777777700006777760760006700000006777077777776067776000119
99115011110655111501110655199999999999999999999999999999999910220677777777777700067777770700067760000007777077777777607777600111
99115051111055111505111055199999999999999999999999999999999910006777777777777700677777770700077770066007777077006777707777760019
99005056611051911505611051999999999999999999999999999999999910677777777777777706777777760600677760076007776067000077706777770011
99005000111051911500011051999999999999999999999999999999999106777777777777777607777777606006777600077067600007000077600677776011
99001101111651900100110651999999999999999999999999999999999107777777776006776000077760067067760066077066067606000077060067777019
99000110000119900010001119999999999999999999999999999999999107777776000000000676077700677777700677077060677760000077000007777019
99999999999999999999999999999999999999999999999999999999999106600770007600000777607600777777760677077606777770000776000007777011
99999999999999999999999999999999999999999999999999999999999100000777777760000777707006777777776077077067700076007760600007777011
99999999999999999999999999999999999999999999999999999999999100000777777770000777707007777777777067777077000007077606700007777011
99999999999999999999999999999999999999999999999999999999999110000777777770600777707067777760777607777077000007077067000007777011
99999999999999999999999999999999999999999999999999999999999911110777777760700777607606700600777707777077000007077606000067777019
99999999999999999999999999999999999999999999999999999999999991110777760006700777007760066000777706777067000067077760000077776019
99999999999999999999999999999999999999999999999999999999999999110777000677700777007777777600777760777007600676077776000677770119
99999999999999999999999999999999999999999999999999999999999911100777000777777777067777777760777770777606777760077777606777760199
99999999999999999999999999999999999999999999999999999999991110067777760777777777077777777770777760777700677600677777706777601199
99999999999999999999999999999999999999999999999999999999991106777777770777777777077777777770777606777760000006707777760776001199
99999999999999999999999999999999999999999999999999999999991067777777760777777777077777777760776067776066666067707776000660011119
99999999999999999999999999999999999999999999999999999999991077760077000677777776077777777700660077770066600077706000066600019119
99999999999999999999999999999999999999999999999999999999991060000067000077777700070677777600000067760000000067600666660000119999
99999999999999999999999999999999999999999999999999999999991000000006000070070700060007006000000007000000000000600006000001199999
99999999999999999999999999999999999999999999999999999999991100000000000066000600000006600000000066000100011000600000000011119999
99999999999999999999999999999999999999999999999999999999991100001111111066000000000106600000100066011111111100001111111119199999
99999999999999999999999999999999999999999999999999999999999111111199999100000001111110011001110001111111199110011119911199999999
99999999999999999999999999999999999999999999999999999999999111199999999911111111999911119119991119911999999911119999999999999999
__label__
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000001111111110000000000000000011000110101100000111111100000000000000000000000000000000000000000
00000000000000000000000000000000000111000000011110000000000111100100110111110011100000011100000000000000000000000000000000000000
00000000000000000000000000000000001100288882000111110001111000102010011111111110000888200010000000000000000000000000000000000000
00000000000000000000000000000000011028888888208011111110000000028011100000000008880288888201100000000000000000000000000000000000
00000000000000000000000000000000110288822288002001000000288820088201028820002208880000888820100000000000000000000000000000000000
00000000000000000000000000000000102888200020808080088802888882028800088800028820280880888880100000000000000000000000000000000000
00000000000000000000000000000000108888000008002000888208820088208820088800088882080880888880100000000000000000000000000000000000
00000000000000000000000000000001108888000028808002882028800008808880088208208888080880880001100000000000000000000000000000000000
00000000000000000000000000000011108888002888800008880088800008808882088028808088088880880111000000000000000000000000000000000000
00000000000000000000000000000011108208888888208808880028800008808888088008208088088880882010000000000000000000000000000000000000
00000000000000000000000000000011102008888222028808880008880088202888888020008000088880888011000000000000000000000000000000000000
00000000000000000000000000000000100008888000088802888220288882000888888080888088080880888001111100000000000000000000000000000000
00000000000000000000000000000000110008888200888200288882028820000880888080288008020280888800000010000000000000000000000000000000
00000000000000000000000000000000010028888800282000000000000000000280082080088822000220288200676010000000000000000000000000000000
00000000000000000000000000000000010088888200000000000000000000000000000082022000000000028007776010000000000000000000000000000000
00000000000000000000000000000000011088820000000000000000677600676000676000000077000676000006770110000000000000000000000000000000
00000000000000000000000000000000111022000677777776000067777700777600077700000677606777000000660100000000000000000000000000000000
00000000000000000000000000000001110000067777777777600077777700777770077600067077007776006760000100000000000000000000000000000000
00000000000000000000000000000000110006777777777777700077777700777760077000677066067770007777600100000000000000000000000000000000
00000000000000000000000000000001000677777777600677760067777760677700676000777700077770067777770100000000000000000000000000000000
00000000000000000000000000000001006777777600000077770007777770077700770006777606077770077777760100000000000000000000000000000000
00000000000000000000000000000010007777776000000077770006777770077706770067776067077776077777600100000000000000000000000000000000
00000000000000000000000000000010067777770000000077760000007770077707770677600077077777077776000100000000000000000000000000000000
00000000000000000000000000000010077777770000000677706777606776067707777777000077067777777770001100000000000000000000000000000000
00000000000000000000000000000010067777770000006777607777760777007707777777760077607777777770011000000000000000000000000000000000
00000000000000000000000000000010066067770000067776067777770777607707777777776077707777777770111000000000000000000000000000000000
00000000000000000000000000000010000007770067777760077777770777777707777777777067706707777770110000000000000000000000000000000000
00000000000000000000000000000011000007777777777600677777770706777706777600777607760606777776011011000000000000000000000000000000
00000000000000000000000000000001100007777777760000777777760700777700777000777707770000777777011111000000000000000000000000000000
00000000000000000000000000000000100067777776000600777777006760677760677000777706776000677777601110000000000000000000000000000000
00000000000000000000000000000000100077777600006700777777077770077770006000777760777000077777760111000000000000000000000000000000
00000000000000000000000000000000100077777000677777777777077770067776000000777770777600077777776011100000000000000000000000000000
00000000000000000000000000000011100077777000777777777777077770007777600000777760677760067777777601100000000000000000000000000000
00000000000000000000000000000110000677777600777777777776067776006777777700777600077770006777777760100000000000000000000000000000
00000000000000000000000000000100067777777770777777777770000677000777777600776000067760000706777660100000000000000000000000000000
00000000000000000000000000001100677777777760777777777760000006000677760000660000007000000600000000100000000000000000000000000000
00000000000000000000000000001100677777777000677777777000100066000066000000000010006600000000000001100000000000000000000000000000
00000000000000000000000000000100067776077000070007007000111066000000000000000111006600110000000001000000000000000000000000000000
00000000000000000000000000001110000700067000066000006000111000000000000010001101110001111110000011000000000000000000000000000000
00000000000000000000000000000110000701006011066000000011110111110000001111111011111111000001111100000000000000000000000000000000
00000000000000000000000000000011111001110011100000111110000000011000111111110011001100000000000000000000000000000000000000000000
00000000000000000000000000000011110110001100011111000000000000000111001100000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000c22000000000000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000000000000000c2220000000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000000000c222222442000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000c24444422222200000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000c20c44444444444442000000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c20e24f444444444f44200000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c2e22fffffff4f4fff44e0000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000c24244444f4f4ff44444420000000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000c244424444444444444444e000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c22244444244444444444e000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000c2422e2224e244444424e000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000c2222002ee20224ee442e000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c22242e00eee02e22e222e000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c2242ff44eff4f4422222e000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c2442fffffffff222992ee000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000c20c240fff2082ff24299ee2200000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000c22244400ff88ff2242442242e0000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000c24444e2670062e42444442ee0000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000c224444286764ef2444442ee00000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000000c224440222224ff24444442000000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c244200000244676444442e00000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000c4626777700066764442ee00000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000000000c2662777787fe28882427ee00000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000000c33328826772287ff2822821e7300000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000c1333555567727726f46b73331333e0000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000000000cc73556277726667241b7b037c351e0000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000cc7c35226776166671111166cc731510000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000c1cc628822221666211116611133651e000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000c053302222021066620161111333150e000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000c051333111110526622611179331330e000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000c551633311110526682211997310333e000000000000000000000000000000000000000000000000
000000000000000000000000000000000000000000000000c551619331111028688211193310633e000000000000000000000000000000000000000000000000
0000000000000000000000000000000000000000000cbb000555169793300002888200033306155000bb10000000000000000000000000000000000000000000
000000000000000000000000000000000000000cee11b7b0055551970333330022200003306155500b7b511ee000000000000000000000000000000000000000
00000000000000000000000000000000000000c1eee3333333975516603833333000003338755553333333eee100000000000000000000000000000000000000
0000000000000000000000000000000000000c15e73333333379555551187833b333313387855b5333333337e510000000000000000000000000000000000000
0000000000000000000000000000000000000cc5333995611339555666678666b7b313331385b7511659793335ce000000000000000000000000000000000000
0000000000000000000000000000000000000c733336956113355660000000007b00333133337b5116599633337e000000000000000000000000000000000000
0000000000000000000000000000000000000c33381005511533608111111111111337e6c733335115500018333e000000000000000000000000000000000000
0000000000000000000000000000000000000c3786005551153338711111111113333e717c10333115555006873e000000000000000000000000000000000000
0000000000000000000000000000000000000c388550055110533378111e7103333611e1c111973115500055883e000000000000000000000000000000000000
0000000000000000000000000000000000000c15560199533010333811e7e333379111111119793335991106551e000000000000000000000000000000000000
0000000000000000000000000000000000000c15501197933010133311e33333597111111111013339791110551e000000000000000000000000000000000000
00000000000000000000000000000000000000c18811933313167c331333330009000111111061013339611881ee000000000000000000000000000000000000
0000000000000000000000000000000000000c31878133311333c713333300b70000000011065331133331878130000000000000000000000000000000000000
0000000000000000000000000000000000000cc733337e100e33c33333313b7b3337e0000633333001e7e33337ce000000000000000000000000000000000000
0000000000000000000000000000000000000ccc3333e1000e01333336633333333e7333333333e0001ee3333cce000000000000000000000000000000000000
000000000000000000000000000000000000000eeeeeeeeeee0eeeeeeeeeeeeeeeeeeeeeeeeeeee0eeeeeeeeeeee000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000033000000000000000000000000000000000000033302220333022000000202000000000000000000000020000000000000000000000
00000000000000000000300020203300222003302220333002200330000000302020003002000000202003302200033022203330020000000000000000000000
00000000000000000000300020203030020030000200333020203000000033302020333002000000202030302020303002003300020000000000000000000000
00000000000000000000300022203300020000300200303022200030000030002020300002000000202033302020333002003000000000000000000000000000
00000000000000000000033020203030222033000200303020203300000033302220333022200000022030002200303002000330020000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
00000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000

__sfx__
b7100020002750020500275002050a27500275002050027500205002750a275002750c275002750a27500275002750020500275002050a27500275002050027500205002750a275002750c275002750a27500275
b710002018a7518a0018a7518a0018a7518a000ca7021a7522a0021a7518a0015a7021a5021a4515a7020a7518a0020a7518a0015a7020a5020a4515a7020a7518a0020a7518a0015a701ba601ba751ba601ba75
010100000027000270002700027000270002700027000270002700027000270002700027000270002700027000270002700027000270002700027000270002700027000270002700027000270002700027000270
000100002d0503205028050230501e050190501805017050170000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
b7100020002750020500275002050a27500275002050027500205002750a275002750c275002750a27500275002750020000200002000a20000200002000020000200002000a200002000c200002000a20000200
01080000290502d05030050290402d04030040290302d03030030290202d02030020290102d010300102901000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
001000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
011000000c073000030c600000000c673000030c073000030c600000000c073000030c6730000311673000030c073000030c600000000c673000030c073000030c600000000c073000030c673000031167300003
0110000000623000000c623000001862300000006230000300623000000c623000001862300000006230000000623000000c623000001862300000006230000300623000000c6230000018623000000062300000
011000000c073000030c600000000c673000030c073000030c600000000c073000030c673000000c073116730c073000030c600000000c673000030c073000030c600000000c073000030c673000030c07311673
011000202463024620246202460020600206002060000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000
011000000c073000030c600000000c673000030c073000030c600000000c073000030c6730000311673000030c073000030c000000000c673000030c000000030c073000000c000000030c673000030c00000003
0110000000623006000c623006001862300600006230060000623006000c623006001862300600006230060000623006230c623006231862300623006230062300623006230c6230062318623006230062300623
d11000001674016740167401674016740167401674016740167301673016730167301673016730167301673016720167201672016720167201672016720167201671016710167101671016710167101671016710
d11000001674016740167401674016740167401674016740167301673016730167301672016720167201671022700227002270022700227002270022700227002270022700227002270022700227002270022700
d11000001f7401f7401f7301f7301f7001f7001c7401c7401c7301c7301c7201c7201c7001c7001b7401b7401b7401b7401b7301b7301b7301b7301b7201b7201b7201b7201b7101b7101b7101b7101b7001b700
__music__
00 08004909
00 0c044d0d
01 08004909
00 08004909
00 08004909
00 0c044d0d
00 0a010950
00 0a010950
00 0a010950
02 0a010950

